unit Unit1;

interface

// https://ing.dk/artikel/taenkeboks-find-tid-med-forskellige-cifre-255317

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  dateutils,
  permutation;

procedure TForm1.Button1Click(Sender: TObject);
var
  PG: TPermutation;
  day,month,hour: integer;
  s: string;
  w: longword;
  SL: TStringList;
begin
  w:= gettickcount;
  PG:= TPermutation.create(10);
  SL:= TStringList.Create;
  while PG.hasMore do
  begin
    PG.Next;   // MM/dd hh:mm:ss
    if (PG.indices[0]<2) and
       (PG.indices[2]<4) and
       (PG.indices[4]<3) and
       (PG.indices[6]<6) and
       (PG.indices[8]<6) then
    begin
      Month:= PG.indices[0]*10+PG.indices[1];
      if month>12 then continue;   // max 12

      Day:= PG.indices[2]*10+PG.indices[3];
      if day>31 then continue;   // max 31

      if day>DaysInAMonth(2022,month) then continue;

      Hour:= PG.indices[4]*10+PG.indices[5];
      if Hour>23 then continue;   // max 23

      s:=   inttostr(PG.indices[0])+inttostr(PG.indices[1])+'/';
      s:= s+inttostr(PG.indices[2])+inttostr(PG.indices[3])+' ';
      s:= s+inttostr(PG.indices[4])+inttostr(PG.indices[5])+':';
      s:= s+inttostr(PG.indices[6])+inttostr(PG.indices[7])+':';
      s:= s+inttostr(PG.indices[8])+inttostr(PG.indices[9]);
      SL.Add(s);
    end;
  end;
  SL.Sort;
  w:= gettickcount-w;

  memo1.Lines.Add('Frste: '+SL.strings[0]);
  memo1.Lines.Add('Sidste: '+SL.strings[SL.Count-1]);
  memo1.Lines.Add(inttostr(w)+' msec');
  memo1.Lines.Add(inttostr(SL.Count)+' ialt');
end;

end.
